DECLARE
   l_result INTEGER := -1;
BEGIN
   dbms_session.set_identifier('bcoulam');
   
   l_result := dbms_pipe.create_pipe(pipename => 'DEBUGPIPE', private => TRUE);
   dbms_pipe.pack_message(item => 'BEGIN subroutine 1'); -- put data item into local buffer
   l_result := dbms_pipe.send_message('DEBUGPIPE'); -- send contents of local buffer to pipe
   dbms_lock.sleep(5); -- pretend to do something useful
   
   dbms_pipe.pack_message(item => 'FINISH subroutine 1');
   l_result := dbms_pipe.send_message('DEBUGPIPE'); -- send contents of local buffer to pipe
   
   dbms_pipe.pack_message(item => 'BEGIN subroutine 2');
   l_result := dbms_pipe.send_message('DEBUGPIPE'); -- send contents of local buffer to pipe
   dbms_lock.sleep(5);
   
   dbms_pipe.pack_message(item => 'FINISH subroutine 2');
   l_result := dbms_pipe.send_message('DEBUGPIPE'); -- send contents of local buffer to pipe
   
   dbms_pipe.pack_message(item => 'Done');
   l_result := dbms_pipe.send_message('DEBUGPIPE'); -- send contents of local buffer to pipe
   dbms_lock.sleep(2);
   
   dbms_pipe.purge('DEBUGPIPE'); -- not technically necessary, but good manners
END;
/

-- Run this after shutting down the event monitor (pipe client)
DECLARE
   l_result INTEGER := -1;
BEGIN
   l_result := dbms_pipe.remove_pipe('DEBUGPIPE');
END;
/
